gi-gtk3-3.0.44: Gtk 3.x bindings

Copyright | Will Thompson and Iñaki García Etxebarria
License | LGPL-2.1
Maintainer | Iñaki García Etxebarria
Safe Haskell | None
Language | Haskell2010

GI.Gtk.Objects.TreeModelSort

Contents

- Exported types
- Methods
  - clearCache
  - convertChildIterToIter
  - convertChildPathToPath
  - convertIterToChildIter
  - convertPathToChildPath
  - getModel
  - iterIsValid
  - newWithModel
  - resetDefaultSortFunc
- Properties
  - model

Description

The `TreeModelSort` is a model which implements the `TreeSortable` interface. It does not hold any data itself, but rather is created with a child model and proxies its data. It has identical column types to this child model, and the changes in the child are propagated. The primary purpose of this model is to provide a way to sort a different model without modifying it. Note that the sort function used by `TreeModelSort` is not guaranteed to be stable.

The use of this is best demonstrated through an example. In the following sample code we create two `TreeView` widgets each with a view of the same data. As the model is wrapped here by a `TreeModelSort`, the two `GtkTreeViews` can each sort their view of the data without affecting the other. By contrast, if we simply put the same model in each widget, then sorting the first would sort the second.

## Using a `TreeModelSort`

### C code

    {
      GtkTreeView *tree_view1;
      GtkTreeView *tree_view2;
      GtkTreeModel *sort_model1;
      GtkTreeModel *sort_model2;
      GtkTreeModel *child_model;

      // get the child model
      child_model = get_my_model ();

      // Create the first tree
      sort_model1 = gtk_tree_model_sort_new_with_model (child_model);
      tree_view1 = gtk_tree_view_new_with_model (sort_model1);

      // Create the second tree
      sort_model2 = gtk_tree_model_sort_new_with_model (child_model);
      tree_view2 = gtk_tree_view_new_with_model (sort_model2);

      // Now we can sort the two models independently
      gtk_tree_sortable_set_sort_column_id (GTK_TREE_SORTABLE (sort_model1),
                                            COLUMN_1, GTK_SORT_ASCENDING);
      gtk_tree_sortable_set_sort_column_id (GTK_TREE_SORTABLE (sort_model2),
                                            COLUMN_1, GTK_SORT_DESCENDING);
    }

To demonstrate how to access the underlying child model from the sort model, the next example will be a callback for the `TreeSelection` TreeSelection::changed signal. In this callback, we get a string from COLUMN_1 of the model. We then modify the string, find the same selected row on the child model, and change the row there.

## Accessing the child model of in a selection changed callback

### C code

    void
    selection_changed (GtkTreeSelection *selection, gpointer data)
    {
      GtkTreeModel *sort_model = NULL;
      GtkTreeModel *child_model;
      GtkTreeIter sort_iter;
      GtkTreeIter child_iter;
      char *some_data = NULL;
      char *modified_data;

      // Get the current selected row and the model.
      if (! gtk_tree_selection_get_selected (selection,
                                             &sort_model,
                                             &sort_iter))
        return;

      // Look up the current value on the selected row and get
      // a new value to change it to.
      gtk_tree_model_get (GTK_TREE_MODEL (sort_model), &sort_iter,
                          COLUMN_1, &some_data,
                          -1);

      modified_data = change_the_data (some_data);
      g_free (some_data);

      // Get an iterator on the child model, instead of the sort model.
      gtk_tree_model_sort_convert_iter_to_child_iter (GTK_TREE_MODEL_SORT (sort_model),
                                                      &child_iter,
                                                      &sort_iter);

      // Get the child model and change the value of the row. In this
      // example, the child model is a GtkListStore. It could be any other
      // type of model, though.
      child_model = gtk_tree_model_sort_get_model (GTK_TREE_MODEL_SORT (sort_model));
      gtk_list_store_set (GTK_LIST_STORE (child_model), &child_iter,
                          COLUMN_1, &modified_data,
                          -1);
      g_free (modified_data);
    }

Synopsis

- newtype TreeModelSort = TreeModelSort (ManagedPtr TreeModelSort)
- class (GObject o, IsDescendantOf TreeModelSort o) => IsTreeModelSort o
- toTreeModelSort :: (MonadIO m, IsTreeModelSort o) => o -> m TreeModelSort
- treeModelSortClearCache :: (HasCallStack, MonadIO m, IsTreeModelSort a) => a -> m ()
- treeModelSortConvertChildIterToIter :: (HasCallStack, MonadIO m, IsTreeModelSort a) => a -> TreeIter -> m (Bool, TreeIter)
- treeModelSortConvertChildPathToPath :: (HasCallStack, MonadIO m, IsTreeModelSort a) => a -> TreePath -> m (Maybe TreePath)
- treeModelSortConvertIterToChildIter :: (HasCallStack, MonadIO m, IsTreeModelSort a) => a -> TreeIter -> m TreeIter
- treeModelSortConvertPathToChildPath :: (HasCallStack, MonadIO m, IsTreeModelSort a) => a -> TreePath -> m (Maybe TreePath)
- treeModelSortGetModel :: (HasCallStack, MonadIO m, IsTreeModelSort a) => a -> m TreeModel
- treeModelSortIterIsValid :: (HasCallStack, MonadIO m, IsTreeModelSort a) => a -> TreeIter -> m Bool
- treeModelSortNewWithModel :: (HasCallStack, MonadIO m, IsTreeModel a) => a -> m TreeModelSort
- treeModelSortResetDefaultSortFunc :: (HasCallStack, MonadIO m, IsTreeModelSort a) => a -> m ()
- constructTreeModelSortModel :: (IsTreeModelSort o, MonadIO m, IsTreeModel a) => a -> m (GValueConstruct o)
- getTreeModelSortModel :: (MonadIO m, IsTreeModelSort o) => o -> m TreeModel

# Exported types

newtype TreeModelSort Source #

Memory-managed wrapper type.

Constructors

TreeModelSort (ManagedPtr TreeModelSort) |

#### Instances

Instances details

Eq TreeModelSort Source # |
Instance details Defined in GI.Gtk.Objects.TreeModelSort Methods (==) :: TreeModelSort -> TreeModelSort -> Bool Source # (/=) :: TreeModelSort -> TreeModelSort -> Bool Source #
GObject TreeModelSort Source # |
Instance details Defined in GI.Gtk.Objects.TreeModelSort
ManagedPtrNewtype TreeModelSort Source # |
Instance details Defined in GI.Gtk.Objects.TreeModelSort Methods toManagedPtr :: TreeModelSort -> ManagedPtr TreeModelSort Source #
TypedObject TreeModelSort Source # |
Instance details Defined in GI.Gtk.Objects.TreeModelSort Methods glibType :: IO GType Source #
HasParentTypes TreeModelSort Source # |
Instance details Defined in GI.Gtk.Objects.TreeModelSort
IsGValue (Maybe TreeModelSort) Source # | Convert `TreeModelSort` to and from `GValue`. See `toGValue` and `fromGValue`.
Instance details Defined in GI.Gtk.Objects.TreeModelSort Methods gvalueGType_ :: IO GType Source # gvalueSet_ :: Ptr GValue -> Maybe TreeModelSort -> IO () Source # gvalueGet_ :: Ptr GValue -> IO (Maybe TreeModelSort) Source #
type ParentTypes TreeModelSort Source # |
Instance details Defined in GI.Gtk.Objects.TreeModelSort type ParentTypes TreeModelSort = '[Object, TreeDragSource, TreeModel, TreeSortable]

class (GObject o, IsDescendantOf TreeModelSort o) => IsTreeModelSort o Source #

Type class for types which can be safely cast to `TreeModelSort`, for instance with `toTreeModelSort`.

#### Instances

Instances details

(GObject o, IsDescendantOf TreeModelSort o) => IsTreeModelSort o Source # |
Instance details Defined in GI.Gtk.Objects.TreeModelSort

toTreeModelSort :: (MonadIO m, IsTreeModelSort o) => o -> m TreeModelSort Source #

Cast to `TreeModelSort`, for types for which this is known to be safe. For general casts, use `castTo`.

# Methods

### Click to display all available methods, including inherited ones

Expand

#### Methods

bindProperty, bindPropertyFull, clearCache, convertChildIterToIter, convertChildPathToPath, convertIterToChildIter, convertPathToChildPath, dragDataDelete, dragDataGet, filterNew, forceFloating, foreach, freezeNotify, getv, hasDefaultSortFunc, isFloating, iterChildren, iterHasChild, iterIsValid, iterNChildren, iterNext, iterNthChild, iterParent, iterPrevious, notify, notifyByPspec, ref, refNode, refSink, resetDefaultSortFunc, rowChanged, rowDeleted, rowDraggable, rowHasChildToggled, rowInserted, rowsReordered, runDispose, sortColumnChanged, stealData, stealQdata, thawNotify, unref, unrefNode, watchClosure.

#### Getters

getColumnType, getData, getFlags, getIter, getIterFirst, getIterFromString, getModel, getNColumns, getPath, getProperty, getQdata, getSortColumnId, getStringFromIter, getValue.

#### Setters

setData, setDataFull, setDefaultSortFunc, setProperty, setSortColumnId, setSortFunc.

## clearCache

treeModelSortClearCache Source #

Arguments

:: (HasCallStack, MonadIO m, IsTreeModelSort a) |
=> a | `treeModelSort`: A `TreeModelSort`
-> m () |

This function should almost never be called. It clears the `treeModelSort` of any cached iterators that haven’t been reffed with `treeModelRefNode`. This might be useful if the child model being sorted is static (and doesn’t change often) and there has been a lot of unreffed access to nodes. As a side effect of this function, all unreffed iters will be invalid.

## convertChildIterToIter

treeModelSortConvertChildIterToIter Source #

Arguments

:: (HasCallStack, MonadIO m, IsTreeModelSort a) |
=> a | `treeModelSort`: A `TreeModelSort`
-> TreeIter | `childIter`: A valid `TreeIter` pointing to a row on the child model
-> m (Bool, TreeIter) | Returns: `True`, if `sortIter` was set, i.e. if `sortIter` is a valid iterator pointer to a visible row in the child model.

Sets `sortIter` to point to the row in `treeModelSort` that corresponds to the row pointed at by `childIter`. If `sortIter` was not set, `False` is returned. Note: a boolean is only returned since 2.14.

## convertChildPathToPath

treeModelSortConvertChildPathToPath Source #

Arguments

:: (HasCallStack, MonadIO m, IsTreeModelSort a) |
=> a | `treeModelSort`: A `TreeModelSort`
-> TreePath | `childPath`: A `TreePath` to convert
-> m (Maybe TreePath) | Returns: A newly allocated `TreePath`, or `Nothing`

Converts `childPath` to a path relative to `treeModelSort`. That is, `childPath` points to a path in the child model. The returned path will point to the same row in the sorted model. If `childPath` isn’t a valid path on the child model, then `Nothing` is returned.

## convertIterToChildIter

treeModelSortConvertIterToChildIter Source #

Arguments

:: (HasCallStack, MonadIO m, IsTreeModelSort a) |
=> a | `treeModelSort`: A `TreeModelSort`
-> TreeIter | `sortedIter`: A valid `TreeIter` pointing to a row on `treeModelSort`.
-> m TreeIter |

Sets `childIter` to point to the row pointed to by `sortedIter`.

## convertPathToChildPath

treeModelSortConvertPathToChildPath Source #

Arguments

:: (HasCallStack, MonadIO m, IsTreeModelSort a) |
=> a | `treeModelSort`: A `TreeModelSort`
-> TreePath | `sortedPath`: A `TreePath` to convert
-> m (Maybe TreePath) | Returns: A newly allocated `TreePath`, or `Nothing`

Converts `sortedPath` to a path on the child model of `treeModelSort`. That is, `sortedPath` points to a location in `treeModelSort`. The returned path will point to the same location in the model not being sorted. If `sortedPath` does not point to a location in the child model, `Nothing` is returned.

## getModel

treeModelSortGetModel Source #

Arguments

:: (HasCallStack, MonadIO m, IsTreeModelSort a) |
=> a | `treeModel`: a `TreeModelSort`
-> m TreeModel | Returns: the "child model" being sorted

Returns the model the `TreeModelSort` is sorting.

## iterIsValid

treeModelSortIterIsValid Source #

Arguments

:: (HasCallStack, MonadIO m, IsTreeModelSort a) |
=> a | `treeModelSort`: A `TreeModelSort`.
-> TreeIter | `iter`: A `TreeIter`.
-> m Bool | Returns: `True` if the iter is valid, `False` if the iter is invalid.

    This function is slow. Only use it for debugging and\/or testing
    purposes.

Checks if the given iter is a valid iter for this `TreeModelSort`.

Since: 2.2

## newWithModel

treeModelSortNewWithModel Source #

Arguments

:: (HasCallStack, MonadIO m, IsTreeModel a) |
=> a | `childModel`: A `TreeModel`
-> m TreeModelSort | Returns: A new `TreeModelSort`.

Creates a new `TreeModelSort`, with `childModel` as the child model.

## resetDefaultSortFunc

treeModelSortResetDefaultSortFunc Source #

Arguments

:: (HasCallStack, MonadIO m, IsTreeModelSort a) |
=> a | `treeModelSort`: A `TreeModelSort`
-> m () |

This resets the default sort function to be in the “unsorted” state. That is, it is in the same order as the child model. It will re-sort the model to be in the same order as the child model only if the `TreeModelSort` is in “unsorted” state.

# Properties

## model

No description available in the introspection data.

constructTreeModelSortModel :: (IsTreeModelSort o, MonadIO m, IsTreeModel a) => a -> m (GValueConstruct o) Source #

Construct a `GValueConstruct` with valid value for the “`model`” property. This is rarely needed directly, but it is used by `new`.

getTreeModelSortModel :: (MonadIO m, IsTreeModelSort o) => o -> m TreeModel Source #

Get the value of the “`model`” property. When overloading is enabled, this is equivalent to

    get treeModelSort #model